// SOLUTION TO THE 4 EXERCISES OF NK_MODEL.MOD


// EXERCISE 1 
var r y p g u eer;    
varexo eg eu er;  
parameters phi betta theta psir psiy psip rhog rhou sigg sigu sigr;
 
phi= 1;
betta= 0.99;
theta= 0.75;
psir= 0.8;
psiy= 0.5;
psip= 1.7;
rhog= 0.85;
rhou= 0.85;
   
model(linear); 
          y = y(1)-(1/phi)*(r-p(1))+g;
          p = betta*p(1)+((1-theta)*(1-betta*theta)/theta)*phi*y+u;
          r = psir*r(-1)+(1-psir)*(psip*p(+1) + psiy*y(+1)) + eer;
          g = rhog*g(-1)+eg;
          u = rhou*u(-1)+eu;
          eer =0*eer(-1)+er;
end; 

shocks;
var eg; stderr 0.1;
var eu; stderr 0.1;
var er; stderr 0.1;
end;

steady(solve_algo=0);  // calculate steady states (solve_algo=0 use FSOLVE, solve_algo=1 us DYNARE SOLVER)
check; // check the eigenvalues of the system
stoch_simul(periods=200,irf=20,simul_seed=3) y p r;

clear all
// EXERCISE 2 
var r y p g u eer;    
varexo eg eu er;  
parameters phi betta theta psir psiy psip rhog rhou sigg sigu sigr a12 a21;
 
phi= 1;
betta= 0.99;
theta= 0.75;
psir= 0.8;
psiy= 0.5;
psip= 1.7;
rhog= 0.85;
rhou= 0.85;
a12 = 0.1;
a21 = 0.1;
  
model(linear); 
          y = y(1)-(1/phi)*(r-p(1))+g;
          p = betta*p(1)+((1-theta)*(1-betta*theta)/theta)*phi*y+u;
          r = psir*r(-1)+(1-psir)*(psip*p(-1) + psiy*y(-1)) + eer;
          g = a12*u+rhog*g(-1)+eg;
          u = a21*g+rhou*u(-1)+eu;
          eer =0*eer(-1)+er;
end; 

shocks;
var eg; stderr 0.1;
var eu; stderr 0.1;
var er; stderr 0.1;
end;

steady(solve_algo=0);  // calculate steady states (solve_algo=0 use FSOLVE, solve_algo=1 us DYNARE SOLVER)
check; // check the eigenvalues of the system
stoch_simul(periods=200,irf=20,simul_seed=3) y p r;


clear all
// EXERCISE 3 
var r y p g u eer;    
varexo eg eu er;  
parameters phi betta theta psir psiy psip rhog rhou sigg sigu sigr a1;
 
phi= 1;
betta= 0.99;
theta= 0.75;
psir= 0.8;
psiy= 0.5;
psip= 1.7;
rhog= 0.85;
rhou= 0.85;
a1 = 0.5;   
model(linear); 
          y = y(1)-(1/phi)*(r-p(1))+g;
          p = a1*p(-1)+(1-a1)*p(1)+((1-theta)*(1-betta*theta)/theta)*phi*y+u;
          r = psir*r(-1)+(1-psir)*(psip*p(+1) + psiy*y(+1)) + eer;
          g = rhog*g(-1)+eg;
          u = rhou*u(-1)+eu;
          eer =0*eer(-1)+er;
end; 

shocks;
var eg; stderr 0.1;
var eu; stderr 0.1;
var er; stderr 0.1;
end;

steady(solve_algo=0);  // calculate steady states (solve_algo=0 use FSOLVE, solve_algo=1 us DYNARE SOLVER)
check; // check the eigenvalues of the system
stoch_simul(periods=200,irf=20,simul_seed=3) y p r;

clear all
// exercise 4: 
var r y p g u eer;    
varexo eg eu er;  
parameters phi betta theta psir psiy psip rhog rhou sigg sigu sigr;
 
phi= 1;
betta= 0.99;
theta= 0.75;
psir= 0.8;
psiy= 0.5;
psip= 1.7;
rhog= 0.85;
rhou= 0.85;
   
model(linear); 
          y = y(1)-(1/phi)*(r-p(1))+g;
          p = betta*p(1)+((1-theta)*(1-betta*theta)/theta)*phi*y+u;
          r = psir*r(-1)+(1-psir)*(psip*p(-1) + psiy*y(-1)) + eer;
          g = rhog*g(-1)+eg;
          u = rhou*u(-1)+eu;
          eer =0*eer(-1)+er;
end; 

shocks;
var eg; stderr 0.1;
var eu; stderr 0.1;
var er; stderr 0.1;
end;

steady(solve_algo=0);  // calculate steady states (solve_algo=0 use FSOLVE, solve_algo=1 us DYNARE SOLVER)
check; // check the eigenvalues of the system
stoch_simul(order=2,periods=200,irf=20,simul_seed=3) y p r;



  